﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Lib_MP_Communication;
namespace SDK_Sample
{
    public partial class frmGeneral_AutoPolling : Form
    {
        public cls_MP_SDK m_objSDK;

        private String m_strResponse = "";

        public RichTextBox m_txtResponse;

        // Response Data
        public String strResponse
        {
            get { return m_strResponse;}
        }

        // When Data Recieved
        private void m_objSDK_DataReceive(object sender, EventArgs e)
        {
            Byte[] byData;

            // Remove Event Link
            m_objSDK.DataReceive -= new EventHandler(m_objSDK_DataReceive);

            // Get Data
            byData = m_objSDK.RxData;

            if (byData == null) return;

            Int32 i32RecieveLen = m_objSDK.RxData.Length;

            // Check Format
            if (byData[2] + 4 != i32RecieveLen) return;

            m_strResponse = "";

            m_strResponse += "Response Time:" + DateTime.Now.ToString("HH:mm:ss.fff") + Environment.NewLine;

            if (byData[5] != 0x01)
            {
                m_strResponse = "Response Error:" + byData[5].ToString("X2");
                m_strResponse += m_objSDK.GetReaderErrorName(byData[5]);
                m_txtResponse.Text = m_strResponse;
                return;
            }

            if (byData[5] == 0x01)
            {
                m_strResponse += "Response OK" + Environment.NewLine;
            }

            m_txtResponse.Text = m_strResponse;


        }

        public frmGeneral_AutoPolling()
        {
            InitializeComponent();

            this.TopLevel = false;
        }

        // Send Command
        private void btnSendCommmand_Click(object sender, EventArgs e)
        {
            // Object Empty
            if (m_objSDK == null) return;

            m_objSDK.DataReceive -= new EventHandler(m_objSDK_DataReceive);
            
            m_objSDK.DataReceive += new EventHandler(m_objSDK_DataReceive);

            m_strResponse = "";
            m_txtResponse.Text = "";

            // Send Command
            if (chkKeepState.Checked == false)
            {
                if (rbEnable.Checked == true)
                    m_objSDK.General_AutoPolling(cls_MP_SDK.AutoPolling.Enable);

                if (rbDisable.Checked == true)
                    m_objSDK.General_AutoPolling(cls_MP_SDK.AutoPolling.Disable);
            }
            else
            {
                if (rbEnable.Checked == true)
                    m_objSDK.General_PollingState(cls_MP_SDK.AutoPolling.Enable);

                if (rbDisable.Checked == true)
                    m_objSDK.General_PollingState(cls_MP_SDK.AutoPolling.Disable);
            }


        }

        // Form Shown
        private void frmISO14443A_GetUID_Shown(object sender, EventArgs e)
        {
            // Show Last Result
            if (m_txtResponse == null) return;

            m_txtResponse.Text = m_strResponse;
        }

        // Parent Changed
        private void frmISO14443A_GetUID_ParentChanged(object sender, EventArgs e)
        {
            try
            {
                // Remove Event Link
                m_objSDK.DataReceive -= new EventHandler(m_objSDK_DataReceive);
            }
            catch
            { }
        }

       
    }
}
